class Zoomable {
    
    constructor(object) {

    }
    initScene(image_1,image_2,image_3){

        document.getElementById('percent').innerText = parseInt(window.zoomableConfig.initState * 100) + '%';
        let useCanvas = true;
        let scene = Os({
            id: "zoomable-wrapper",
            zoomInButton:   "zoom-in",
            zoomOutButton:  "zoom-out",
            imageSmoothingEnabled: true,
            //prefixUrl: "/side/zoomable_test_tiled1/assets/lib/images/",
            springStiffness: 12, //6.5 default
            animationTime: 1, //1.2 default
            defaultZoomLevel: window.zoomableConfig.initState,
            constrainDuringPan: false,
            //visibilityRatio: 0.5, //(default: 0.5)
            minPixelRatio: 0.5, //(default: 0.5) 
            minZoomImageRatio:0.005, //(default: 0.8)
            maxZoomPixelRatio:5, //(default: 2) 
            zoomPerClick:1.35,
            zoomPerScroll: 1.095,
            loadTilesWithAjax: false, // Enable in production /!\, remove in local
            ///zoomPerSecond: 1,
            //imageSmoothingEnabled: iosCheck() ? false : true, 
            minZoomLevel :window.zoomableConfig.minState,
            maxZoomLevel :window.zoomableConfig.maxState,
            //showNavigationControl: true,
            gestureSettingsMouse: {
                flickEnabled: false,
                clickToZoom: false,
                dblClickToZoom: true
            },
            showNavigator:   false,
            navigatorTop:      "80px",
            navigatorLeft:    "calc(100% - 165px)",
            navigatorPosition: "ABSOLUTE",
            /*navigatorPosition: "TOP_RIGHT",
            navigatorTop:      "60px",
            navigatorLeft:    "auto",*/
            navigatorHeight:   "120px",
            navigatorWidth:    "145px",
            //smoothTileEdgesMinZoom: "Infinity",
            //debugMode : true,
            //immediateRender: true, // a tester sur safari ?
            /*
             panHorizontal (default: true)
            panVertical (default: true)
            constrainDuringPan (default: false)
            wrapHorizontal (default: false)
            wrapVertical (default: false) 
            */
            //maxImageCacheCount:3,
            tileSources: [ 
                {x: 0,y: 0,opacity: 0,tileSource:image_1},
                {x: 0,y: 0,opacity: 0,tileSource:image_2, preload:true /*buildPyramid: false,*/},
                {x: 0,y: 0,opacity: 0,tileSource:image_3, preload:true},
            ]
        }); 
       

        scene.gestureSettingsMouse.clickToZoom = false;
        return scene;
    }
    // Advanced Fade Function (easing)
    /*fadeElement(image, targetOpacity){

        let fadeSpeed = 30;
        if(mobileCheck()) fadeSpeed = 7;

        if(typeof image != 'undefined'){
            var currentOpacity = image.getOpacity();
            var step = (targetOpacity - currentOpacity) / fadeSpeed;
            if (step === 0) {
                return;
            }
            var frame = function() {
                currentOpacity += step;
                if ((step > 0 && currentOpacity >= targetOpacity) || (step < 0 && currentOpacity <= targetOpacity)) {
                    image.setOpacity(targetOpacity);
                    return;
                }
                image.setOpacity(currentOpacity);
                Os.requestAnimationFrame(frame);
            };
            Os.requestAnimationFrame(frame);
        }
    }*/
    // Standard (no animation) fading function
    fadeElement(image, targetOpacity){
        //if(typeof image != 'undefined'){
            image.setOpacity(targetOpacity);
        //}
    }
    zoom(scene){
        //console.log(scene.world.getItemAt(0),scene.world.getItemAt(1),scene.world.getItemAt(2));
        //if(window.zoomableConfig.debug) 
        //console.log('Your current zoom level : ' + scene.viewport.getZoom());
        document.getElementById('percent').innerText = parseInt(scene.viewport.getZoom() * 100) + '%';

        let min = window.zoomableConfig.minState * 100;
        let max = window.zoomableConfig.maxState * 100 ;
        let percent = (scene.viewport.getZoom() * 100) * 100 / (max - min);
        let percentMin = min * 100 / (max - min);
        let element = document.getElementById('cursor');
        if(element) element.style.left = (percent - percentMin) + '%';

        document.getElementById('zoomable-wrapper').style.background =  "#" + window.zoomableConfig['bg'];

        if(typeof scene.world.getItemAt(0) != 'undefined' && typeof scene.world.getItemAt(1) != 'undefined' && typeof scene.world.getItemAt(2) != 'undefined'){
            document.getElementById('loader').style.display = "none";

            if(window.previousZoom != scene.viewport.getZoom()){
                window.previousZoom = scene.viewport.getZoom();
                //console.log('set previous zoom : ', scene.viewport.getZoom());

                for(let i = 0; i < 3; i++){
                    let image = scene.world.getItemAt(i);
                    let image_conf_1 = window.zoomableConfig['images'][i][0];
                    let image_conf_2 = window.zoomableConfig['images'][i][1];
                    let image_conf_3 = window.zoomableConfig['images'][i][2];
                    let image_conf_4 = window.zoomableConfig['images'][i][3];

                    //if(mobileCheck()){
                        if(window.innerWidth < window.innerHeight){
                            if(i == 1){
                                image_conf_3 += image_conf_3 / 8;
                                image_conf_4 += image_conf_4 / 8;
                            }
                            if(i == 2){
                                image_conf_1 += image_conf_1 / 8;
                                image_conf_2 += image_conf_2 / 8;
                            }
                            // portrait mode, image last a little bit more
                            console.log('should fade at : ',image_conf_1,'will fade at : ',image_conf_1 + image_conf_1 / 8);
                            
                        }
                    //}
                    // First half
                    if(scene.viewport.getZoom() < image_conf_1){
                        //console.log('First half image (hide) : '+i);
                        this.fadeElement(image, 0);
                    // Second half
                    }else if(scene.viewport.getZoom() < image_conf_2){
                        //console.log('Second half image (fade IN) : '+i);
                        let delta = image_conf_1 - image_conf_2;
                        let mouseDelta = scene.viewport.getZoom() - image_conf_2;
                        let invertpercent = 1 - (mouseDelta / delta);
                        //console.log(invertpercent);
                        this.fadeElement(image, invertpercent); // increase
                    }
                    // Third half
                    else if(scene.viewport.getZoom() < image_conf_3){
                        //console.log('Third half image (show) : '+i);
                        this.fadeElement(image, 1);
                    }
                    // Fourth half
                    else if(scene.viewport.getZoom() <= image_conf_4){
                        //console.log('Fourth half image (fade OUT) : '+i);
                        let delta = image_conf_3 - image_conf_4;
                        let mouseDelta = scene.viewport.getZoom() - image_conf_4;
                        let percent = mouseDelta / delta;
                        //console.log(percent);
                        this.fadeElement(image, percent*2); // decrease
                    }else{
                        //console.log('Fifth half image (hide) : '+i);
                        if(i != 2){
                            this.fadeElement(image, 0);
                        }
                        
                    }
                }

            }else{
                //console.log('skip because previous zoom is the same : ', scene.viewport.getZoom());
            }
            

            
        }else{
            if(window.zoomableConfig.debug) console.log('Waiting to load all images...');
        }
    }
}
      
/**
 * Zoomable events
 * 
 */

document.addEventListener("DOMContentLoaded",function(){

    document.getElementById('loader').style.display = "block";

    // Init scene
    let zoomable = new Zoomable();
    let scene = zoomable.initScene(
        document.getElementById('image_1').getAttribute('data-src'),
        document.getElementById('image_2').getAttribute('data-src'),
        document.getElementById('image_3').getAttribute('data-src')
    );

    // Attach event on zoom
    scene.addHandler("zoom", e => { zoomable.zoom(scene); });

});

window.mobileCheck = function() {
    let check = false;
    (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
    return check;
};

window.iosCheck = function() {
    return [
        'iPad Simulator',
        'iPhone Simulator',
        'iPod Simulator',
        'iPad',
        'iPhone',
        'iPod'
      ].includes(navigator.platform)
      // iPad on iOS 13 detection
      || (navigator.userAgent.includes("Mac") && "ontouchend" in document)
};